package com.sun.corba.se.impl.activation;

import com.sun.corba.se.spi.activation.ServerHeldDown;
import com.sun.corba.se.spi.activation.ServerAlreadyActive;
import com.sun.corba.se.spi.activation.ServerNotRegistered;
import com.sun.corba.se.spi.activation.ActivatorHelper;
import org.omg.CORBA.ORB;
import com.sun.corba.se.impl.orbutil.CorbaResourceUtil;
import java.io.PrintStream;

class StartServer implements CommandHandler
{
    static final int illegalServerId = -1;
    
    StartServer() {
    }
    
    @Override
    public String getCommandName() {
        return "startup";
    }
    
    @Override
    public void printCommandHelp(PrintStream printStream, boolean b) {
        if (!b) {
            printStream.println(CorbaResourceUtil.getText("servertool.startserver"));
        }
        else {
            printStream.println(CorbaResourceUtil.getText("servertool.startserver1"));
        }
    }
    
    @Override
    public boolean processCommand(String[] array, ORB orb, PrintStream printStream) {
        int n = -1;
        try {
            if (array.length == 2) {
                if (array[0].equals("-serverid")) {
                    n = (int)Integer.valueOf(array[1]);
                }
                else if (array[0].equals("-applicationName")) {
                    n = ServerTool.getServerIdForAlias(orb, array[1]);
                }
            }
            if (n == -1) {
                return true;
            }
            ActivatorHelper.narrow(orb.resolve_initial_references("ServerActivator")).activate(n);
            printStream.println(CorbaResourceUtil.getText("servertool.startserver2"));
        }
        catch (ServerNotRegistered serverNotRegistered) {
            printStream.println(CorbaResourceUtil.getText("servertool.nosuchserver"));
        }
        catch (ServerAlreadyActive serverAlreadyActive) {
            printStream.println(CorbaResourceUtil.getText("servertool.serverup"));
        }
        catch (ServerHeldDown serverHeldDown) {
            printStream.println(CorbaResourceUtil.getText("servertool.helddown"));
        }
        catch (Exception ex) {
            ex.printStackTrace();
        }
        return false;
    }
}
